C======PROGRAM SIMPLE=====================================================
C
C
C     *Version 4.1: Skip penetrants
C
C     *NPT ensemble - but, may also handle the NVE case
C
C     *Numbering conventions: first pendant groups, then skeletal atoms
C
C              R      R                2   6      
C	         |      |                |   |    
C	       R-Si-CH2-Si-CH2-.... =  1-4-5-8-9-....  , where R = CH3
C              |      |                |   |        
C              R      R                3   7     
C
C
	program simple

C.......DECLARATIONS

	implicit none

	integer IC,IUN,MAXB,maxat,maxdihtyp

c	parameter(IC=200,IUN=10,MAXB=10000)
	parameter(IC=100,IUN=20,MAXB=5000)
	parameter(maxat=20)
	parameter(maxdihtyp=2)


	integer bin,bjn,bkn,natmc,natsu,pol,index
	integer i,i2,i4,ich,iclass(7,-100:100),idbw,iden
	integer identmc(IUN,IC),identsu(IUN,IC) 
	integer idihed(-180:180)
	integer iSkel(-50:50),iPen(-50:50),sutmc(maxat),mctsu(maxat+1)
	integer idummy
	integer itmp,j,jch,k,l,m,maxbin,n,nat
	integer natompen,nbonds,nch,npen,ns,nscan,nstep,ntot,nun
	integer members(6),zeugos(3,3),ndihtyp,ntypdih,dihtype(6,6)
	integer ifalse,ndex,t,t0,t1,t2,kount

	real*8 b(3,IUN,IC),blen(IUN,IC),bxb(3,IUN,IC)
	real*8 const,Coo,costh(7,IUN),d(3,IUN,IC)
	real*8 donst,dr,dhdbnwdth,dlen(IUN,IC),drmij(3)
	real*8 dtheta(7,IUN),eonst,factor,h(3,3),hmin,hi(3,3)
	real*8 inIbxbI(IUN,IC),invpi,invtwopi
	real*8 len,len2,x1,x2,y1,y2,z1,z2,dt,dot
	real*8 nideal,nideam,nidean,prminsq
	real*8 pi,r,r2,rad2deg,rho,rhp,rhq,rlow
	real*8 rmin,rminsq,rmjn,rup,rxmc(IUN,IC)
	real*8 rxl(27),rymc(IUN,IC)
	real*8 ryl(27),rzmc(IUN,IC),rzl(27)
	real*8 theta0(7),tmp1,tmp2,tmp3,rpminsq
	real*8 twopi,vol,x,x0mc(IUN,IC),xl(27),p1,p2
	real*8 xpen0(20,20),y,y0mc(IUN,IC),yl(27)
	real*8 ypen0(20,20),z,z0mc(IUN,IC),zl(27)
	real*8 zbn,zconst(6),zdonst(6),zeonst(6)
	real*8 zpen0(20,20),zrho(6),zrhp(6),zrhq(6)
	real*8 rmini, dri,cosph(5000,IUN,maxdihtyp)
	real*8 rpxmc(IUN,IC),rpymc(IUN,IC),rpzmc(IUN,IC)
	real*8 a,bb,c,csf0,csft

	logical penpresent, penread, bonded

	character*30 dummy,filename, dihname(maxdihtyp)

	common /block/ x0mc, y0mc, z0mc
	common /black/ rxmc, rymc, rzmc
	common /click/ rxl,ryl,rzl
	common /crack/ rpxmc,rpymc,rpzmc

C-------Executable Lines Start Here----------------------------------------

C.......INITIALIZE VARIABLES (and constants)

	pi=3.141593d0
	invpi=1.0d0/pi
	twopi=2.0d0*pi
	invtwopi=1.0d0/twopi
	rad2deg=180.0d0*invpi

	theta0(1)=109.95d0
	theta0(2)=109.95d0
	theta0(3)=109.95d0
	theta0(4)=109.95d0
	theta0(5)=109.23d0
	theta0(6)=107.72d0
	theta0(7)=123.06d0

	len=1.91d0
	len2=len**2

c	classify atom pairs depending on atom kinds 
c	(1=Si, 2=CH2, 3=CH3)

	zeugos(1,1)=1  
	zeugos(2,2)=2 
	zeugos(3,3)=3
	zeugos(1,2)=4
	zeugos(2,1)=4
	zeugos(1,3)=5
	zeugos(3,1)=5
	zeugos(2,3)=6
	zeugos(3,2)=6

c       These are box-scaled translation vectors
c	used in observing PBCs

        do 1 i=1,3
          do 2 j=1,3
            do 3 k=1,3
              l=9*i+3*j+k-12
              xl(l)=dfloat(i-2) 
              yl(l)=dfloat(j-2) 
              zl(l)=dfloat(k-2) 
    3       continue 
    2     continue 
    1   continue

c	Deviations off equil bond angles are stored in iclass
c	dihedrals in idihed and histogr*s for total p.d.f., g(r)
c	and w(r) in hist, hjst and hkst respectively
c	
	do 800 i=-50,50
	  iSkel(i)=0
	  iPen(i)=0
  800	continue
	
        do 11 i=1,7
          do 21 j=-100,100
            iclass(i,j)=0 
   21     continue
   11   continue

	do 12 i=-180,180
	  idihed(i)=0      
   12	continue


	r2=0.0d0
	Coo=0.0d0

C.......READ IN DATA

c  997	write(6,*) 'Insert bin width for dihedrals; no less than 1.0d0'
c    	read(5,*) dhdbnwdth
c	if(dhdbnwdth.lt.1.0d0) then
c	  write(6,*) 'That was less than 1.'
c	  dhdbnwdth=1.0d0
c	  goto 997
c	endif
c	idbw=dint(dhdbnwdth)

c	Read # of config*s stored, then units/chain, atoms/chain, 
c	chains; calculate # of all atoms in the box, 
c	# of SKELETAL bonds

	open(unit=2, file='system.txt')
	read(2,*)
    	read(2,*) dhdbnwdth
	read(2,*)
	read(2,*) dr
	read(2,*)
	read(2,*) filename
	read(2,*)
	read(2,*) ifalse    ! Read Lines written accidentally?
	read(2,*)
	read(2,*) nstep,nscan
	read(2,*)
	read(2,*) nun,natmc,natsu,nch  
	read(2,*)
	read(2,*) penpresent, penread
	if(penpresent) then
	  read(2,*)
	  read(2,*) npen, natompen
	endif
      read(2,*)
	read(2,*) ndihtyp
	do i = 1,ndihtyp
	  read(2,*) m,j,k
	  dihtype(j,k)=m
	enddo
	ntypdih=m
	read(2,*) (dihname(i), i=1,ntypdih)
	read(2,*)
	read(2,*) pol

      do i=1,maxat
	  mctsu(i) = 0
	  sutmc(i) = 0
	end do
	mctsu(maxat+1) = 0
	
	if(pol.eq.1) then
	
	  i=-1
	  Do while(i+2.le.maxat)
	    i=i+2
	    sutmc(i)=i+1
	    mctsu(i)=0

	  End Do

	  i=0
	  Do while(i.lt.maxat)
	    i=i+2
	    sutmc(i)=i
	    mctsu(i)=i
	  End Do
	
	else if(pol.eq.2) then

	  i=-1
	  Do while(i+2.le.maxat)
	    i=i+2
	    sutmc(i)=2*i
	  End Do

	  i=0
	  Do while(i.lt.maxat)
	    i=i+2
	    sutmc(i)=2*i-2
	  End Do

	  do i=1,natmc
	    mctsu(i)=0
	  enddo

	  i=2
	  j=0
	  Do while(i+4.le.maxat)
	    j=j+2
	    mctsu(i)=j
	    i=i+4
	  End Do	
	
	else if(pol.eq.3) then
	
	  Do i=1,natmc
	    read(2,*) j,mctsu(j),sutmc(j)
	  End Do

	Endif
	close(2)

	open(unit=1, file=filename)

	idbw=dint(dhdbnwdth)
	ntot=nch*(4*nun+1)     
c	nbonds=2*nun  ! Only for P1
	nbonds=natmc-1
	mctsu(natmc)=0         

	hmin=1000.0d0

c  996   write(6,*) 'interval for pair distances?'
c        read(5,*) dr
	dri=1.d0/dr

C:::::::START PROCESSING (Keep reading anyway)

c	This is the beginning of a very big loop
c	over all configurations stored
c	It is the main part of the main program

	DO 1333 NS=1,nstep 

c	TEST TEST TEST (NVE)
c	if(NS.eq.1) then 

c	reads the simulation box tensor
	do 14 i=1,3   
	  read(1,*) h(i,1),h(i,2),h(i,3)
c	  read(97,*) h(i,1),h(i,2),h(i,3)
c	  write(6,*) h(i,1),h(i,2),h(i,3)
   14	continue
	write(6,*) NS

c	find min{h(i,j)}
c      hmin = 1000.0d0
	do 15 i=1,3 
	  do 23 j=1,3
	    if((h(i,j).ne.0.0d0).and.(h(i,j).lt.hmin))
     &	    hmin=h(i,j)
   23	  continue
   15	continue

	call matinv(h,hi,vol)

        maxbin=dint(0.5d0*hmin*dri)
        if (maxbin.gt.MAXB) then
          write(6,*) 'Too small an interval.
     &                Choose a bigger one.'
c          goto 996
	  STOP
        endif
c	endif 
c	Last endif is a TEST (NVE)

c	read atom types and coord*s (box scaled)
	do i=1,nch
	  do j=1,natmc
	    read(1,*) iden,x,y,z
c	    read(97,*) iden,x,y,z
	    identmc(j,i)=iden
	    x0mc(j,i)=x
	    y0mc(j,i)=y
	    z0mc(j,i)=z
	 end do
	  do j=1,natsu
	    read(1,*) iden,x,y,z
	 end do
	end do

c	Re-reads the box tensor because it has been
c	accidentally re-written
	if(ifalse.eq.1) then
	  do 989 i=1,3   
	    read(1,*) 
  989	  continue
	End if

c	Penetrants 

	if(penpresent .AND. penread) then  
	  do 17 i=1,npen
	    do 25 j=1,natompen
	      read(1,*) iden,x,y,z
	      xpen0(j,i)=x
	      ypen0(j,i)=y
	      zpen0(j,i)=z
   25 	    continue
   17 	  continue
	endif


C.......OBSERVE PERIODIC BOUNDARY CONDITIONS (just in case)

c	Form real-space translation vectors

	do 18 i=1,27
	  rxl(i)=h(1,1)*xl(i)+h(1,2)*yl(i)+h(1,3)*zl(i) 
	  ryl(i)=h(2,1)*xl(i)+h(2,2)*yl(i)+h(2,3)*zl(i) 
	  rzl(i)=h(3,1)*xl(i)+h(3,2)*yl(i)+h(3,3)*zl(i) 
   18	continue

	do 19 i=1,nch
	  do 26 j=1,natmc
	    k=x0mc(j,i)+x0mc(j,i)
	    l=y0mc(j,i)+y0mc(j,i)
	    m=z0mc(j,i)+z0mc(j,i)
	    n=9*k+3*l+m+14
	    x0mc(j,i)=x0mc(j,i)-xl(n)
	    y0mc(j,i)=y0mc(j,i)-yl(n)
	    z0mc(j,i)=z0mc(j,i)-zl(n)
	    if((dabs(x0mc(j,i)).gt.0.5d0).or.
     &       (dabs(y0mc(j,i)).gt.0.5d0).or.
     &       (dabs(z0mc(j,i)).gt.0.5d0)) then
	      write(6,*) 'Something wrong with PBCs'
	      write(6,*) j,i,x0mc(j,i),y0mc(j,i),z0mc(j,i)
	      STOP
	    endif
   26	  continue
       do j=1,natsu
      enddo
   19 	continue

c	Form and store real space coord*s (in Angstroms)

	do 110 i=1,nch 
	  do 27 j=1,natmc
	    rxmc(j,i)=h(1,1)*x0mc(j,i)+h(1,2)*y0mc(j,i)+h(1,3)*z0mc(j,i)
	    rymc(j,i)=h(2,1)*x0mc(j,i)+h(2,2)*y0mc(j,i)+h(2,3)*z0mc(j,i)
	    rzmc(j,i)=h(3,1)*x0mc(j,i)+h(3,2)*y0mc(j,i)+h(3,3)*z0mc(j,i)
   27	  continue

  110	continue

C.......BONDS FORMATION
C	Form and store bond vectors; then convert them to unit vectors
C	Also, store parent chain coordinates used in finding the pair 
C	distribution functions

c	Loop over chains: bond formation
	do 111 ich=1,nch 

	  do i=1,natmc-1 
	
c 	Form main chain bond
	
	    call minimg(i,ich,1,i+1,ich,1,drmij,rminsq,rpminsq)
	    rmin=dsqrt(rminsq)
	    blen(i,ich)=rmin
	    b(1,i,ich)=drmij(1)
	    b(2,i,ich)=drmij(2)
	    b(3,i,ich)=drmij(3)
	end do


c	  Form parent chain coordinates (skeletal)
c	  used in intramolecular g(r)

	  rpxmc(1,ich)=rxmc(1,ich)
	  rpymc(1,ich)=rymc(1,ich)
	  rpzmc(1,ich)=rzmc(1,ich)

	  do i=2,natmc 
	    rpxmc(i,ich)=rpxmc(i-1,ich)+b(1,i-1,ich)
	    rpymc(i,ich)=rpymc(i-1,ich)+b(2,i-1,ich)
	    rpzmc(i,ich)=rpzmc(i-1,ich)+b(3,i-1,ich)
	  end do



c	  Convert to unit vectors
	  do  i=1,natmc-1 
	    rmini=1.d0/blen(i,ich) 
	    b(1,i,ich)=b(1,i,ich)*rmini
	    b(2,i,ich)=b(2,i,ich)*rmini
	    b(3,i,ich)=b(3,i,ich)*rmini
	  end do
	
c	 Form pendant bond
c

  214	  continue

	   
  111	continue
c	End of loop over chains: bond formation

C.......DIHEDRAL ANGLES
  889	continue

c	Loop over chains: dihedrals
	do 113 ich=1,nch

	  bxb(1,1,ich)=+b(2,1,ich)*b(3,2,ich)
     &		       -b(3,1,ich)*b(2,2,ich)
	  bxb(2,1,ich)=+b(3,1,ich)*b(1,2,ich)
     &		       -b(1,1,ich)*b(3,2,ich)
	  bxb(3,1,ich)=+b(1,1,ich)*b(2,2,ich)
     &		       -b(2,1,ich)*b(1,2,ich)
	  inIbxbI(1,ich)=dsqrt(bxb(1,1,ich)*bxb(1,1,ich)
     &			      +bxb(2,1,ich)*bxb(2,1,ich)
     &			      +bxb(3,1,ich)*bxb(3,1,ich))
	  inIbxbI(1,ich)=1.0d0/inIbxbI(1,ich)
	
	  do 221 i=2,natmc-2
	
	    bxb(1,i,ich)=+b(2,i,ich)*b(3,i+1,ich)
     &			     -b(3,i,ich)*b(2,i+1,ich)
	    bxb(2,i,ich)=+b(3,i,ich)*b(1,i+1,ich)
     &			      -b(1,i,ich)*b(3,i+1,ich)
	    bxb(3,i,ich)=+b(1,i,ich)*b(2,i+1,ich)
     &			     -b(2,i,ich)*b(1,i+1,ich)
	    inIbxbI(i,ich)=dsqrt(bxb(1,i,ich)*bxb(1,i,ich)
     &			        +bxb(2,i,ich)*bxb(2,i,ich)
     &			        +bxb(3,i,ich)*bxb(3,i,ich))
	    inIbxbI(i,ich)=1.0d0/inIbxbI(i,ich)
	
	 l=dihtype(identmc(i,ich),identmc(i+1,ich))

        cosph(NS,i,l)=-(bxb(1,i-1,ich)*bxb(1,i,ich)
     &		       +bxb(2,i-1,ich)*bxb(2,i,ich)
     &               +bxb(3,i-1,ich)*bxb(3,i,ich))
     &		     *inIbxbI(i-1,ich)*inIbxbI(i,ich)

c	    this is obviously the dihedrals accumulator
  221	  continue

       
  113	continue
c	End of loop over chains: dihedrals


 1333	CONTINUE



	close(1)

c	End of the very big loop over all configurations
c	Now we can use the accumulators (iclass,idihed, histograms)
c	to extract meaningful information

C::::::END OF PROCESSING; START EXTRACTING


          do i=1,ntypdih

	 do 191 NS=1,nscan-1
          t1=1
          t2=nstep-NS
          kount=0
	    a=0.
	    bb=0.
	    c=0.
	   do 291 t0=t1,t2
            t=t0+NS
            do 39 index=2,natmc-2
	      csf0=cosph(t0,index,i)
	      csft=cosph(t ,index,i)
            if (csf0.ne.0.d0.and.csft.ne.0.0d0) kount=kount+1  
	      a=a+csf0*csft
	      bb=bb+csf0
	      c=c+csf0*csf0

   39       continue
  291     continue

c	    write(9,*) 'Dihedral Type ', i, dihname(i)
          write(9,*) i,NS,
     &			(a/dfloat(kount)-(bb/dfloat(kount))**2)/  
     &                  (c/dfloat(kount)-(bb/dfloat(kount))**2)

c	    write(6,*) 'Dihedral Type ', i, dihname(i)
          write(6,*) i,NS,
     &		     (a/dfloat(kount)-(bb/dfloat(kount))**2)/  
     &                  (c/dfloat(kount)-(bb/dfloat(kount))**2)
	
  191   continue

	end do
  886	continue
	write(*,*) 'This is the end'

	STOP
	END

C=======That was the end of the main program===============================
C
C
C
C
C=======SUBROUTINE MINIMG==================================================

      subroutine minimg(i,ich,iflag,j,jch,jflag,drmij,rminsq,rpminsq)

	implicit none

C.......DECLARATIONS

C   >	Passed Variables

	integer i,ich,j,jch,iflag,jflag
	integer IC,IUN



c        parameter(IC=200,IUN=5)
        parameter(IC=100,IUN=20)

	real*8 drmij(3),rpminsq,rminsq
	real*8 x0mc(IUN,IC),y0mc(IUN,IC),z0mc(IUN,IC)
	real*8 rpxmc(IUN,IC),rpymc(IUN,IC),rpzmc(IUN,IC)
	real*8 rxmc(IUN,IC),rymc(IUN,IC),rzmc(IUN,IC)
      real*8 rxl(27),ryl(27),rzl(27)

	common /block/ x0mc, y0mc, z0mc
	common /black/ rxmc, rymc, rzmc
	common /click/ rxl,ryl,rzl
	common /crack/ rpxmc,rpymc,rpzmc

C   > 	Local Variables

	integer ll,nx,ny,nz
	real*8 drx,dry,drz,dx0,dy0,dz0
	real*8 rxi,rxj,ryi,ryj,rzi,rzj
	real*8 x0i,x0j,y0i,y0j,z0i,z0j
	real*8 zbn,rpxi,rpyi,rpzi,rpxj,rpyj,rpzj

C------Executable Lines Start Here-----------------------------------------

	if(iflag.eq.1) then

       	x0i=x0mc(i,ich)
	  y0i=y0mc(i,ich)
	  z0i=z0mc(i,ich)
	  rxi=rxmc(i,ich)
	  ryi=rymc(i,ich)
	  rzi=rzmc(i,ich)
          rpxi=rpxmc(i,ich)
          rpyi=rpymc(i,ich)
          rpzi=rpzmc(i,ich)

 	endif
	if(x0i.eq.0.5d0) x0i=0.499999d0
	if(x0i.eq.-0.5d0) x0i=-0.499999d0
	if(x0j.eq.0.5d0) x0j=0.499999d0
	if(x0j.eq.-0.5d0) x0j=-0.499999d0


	if(jflag.eq.1) then

       	  x0j=x0mc(j,jch)
	  y0j=y0mc(j,jch)
	  z0j=z0mc(j,jch)
	  rxj=rxmc(j,jch)
	  ryj=rymc(j,jch)
	  rzj=rzmc(j,jch)
          rpxj=rpxmc(j,jch)
          rpyj=rpymc(j,jch)
          rpzj=rpzmc(j,jch)

          
	endif


	drx=rxj-rxi
	dry=ryj-ryi
	drz=rzj-rzi

	dx0=x0j-x0i
	dy0=y0j-y0i
	dz0=z0j-z0i

	nx=dx0+dx0
	ny=dy0+dy0
	nz=dz0+dz0

	ll=9*nx+3*ny+nz+14

	drmij(1)=drx-rxl(ll)
	drmij(2)=dry-ryl(ll)
	drmij(3)=drz-rzl(ll)

	rminsq=drmij(1)*drmij(1)+drmij(2)*drmij(2)
     &        +drmij(3)*drmij(3)

	zbn=0.0d0 
	zbn=zbn+(rpxi-rpxj)**2
	zbn=zbn+(rpyi-rpyj)**2
	zbn=zbn+(rpzi-rpzj)**2

	rpminsq=zbn


      return
	end

C=====End of subroutine minimg=============================================
C
C
C
C
C=====SUBROUTINE MATINV====================================================	

      subroutine matinv(a,b,c)

c     Invert a 3 x 3 matrix in a, return in result in b, 
c     put determinant in c.

c      implicit double precision (a-h,o-z),integer (i-n)
c      dimension a(3,3),b(3,3)

C.....DECLARATIONS

      implicit none

      real*8 a(3,3), b(3,3), d11,d22,d33,d12,d13,d21,d23,d31,d32,cinv,c

C-----Executable Lines Start Here------------------------------------------

      d11=a(2,2)*a(3,3)-a(2,3)*a(3,2)
      d22=a(3,3)*a(1,1)-a(3,1)*a(1,3)
      d33=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      d12=a(2,3)*a(3,1)-a(2,1)*a(3,3)
      d23=a(3,1)*a(1,2)-a(3,2)*a(1,1)
      d31=a(1,2)*a(2,3)-a(1,3)*a(2,2)
      d13=a(2,1)*a(3,2)-a(3,1)*a(2,2)
      d21=a(3,2)*a(1,3)-a(1,2)*a(3,3)
      d32=a(1,3)*a(2,1)-a(2,3)*a(1,1)
      c=a(1,1)*d11+a(1,2)*d12+a(1,3)*d13
      cinv = 1.0d0 / c

      b(1,1)=d11 * cinv
      b(2,2)=d22 * cinv
      b(3,3)=d33 * cinv
      b(1,2)=d21 * cinv
      b(2,3)=d32 * cinv
      b(3,1)=d13 * cinv
      b(2,1)=d12 * cinv
      b(3,2)=d23 * cinv
      b(1,3)=d31 * cinv

      return
      end

C=======End of subroutine matinv===========================================
C
C
C
C=======Function Bonded====================================================

	logical function bonded(i,j)

	implicit none

	integer i,j

	integer k,l

	bonded = .false.

C-------Executable part starts here----------------------------------------
C
c	Criteria for identifying atoms separated by ONE bond

	k = j-4*(j/4)
	l = (j-i-3)*(j-i-2)*(j-i-1)

	if((k.eq.0).and.(l.eq.0)) then
c	if(abs(k)+abs(l).eq.0) then
	  bonded = .true.
	  return
	endif

	l=j-i-1

	if((k.eq.1).and.(l.eq.0)) then
	  bonded = .true.
	  return
	endif


c	Criteria for identifying atoms separated by TWO bonds
c
c	Skeletal Bond Angles:
c			k=i-4*(i/4), l=j-4*(j/4), m=j-i
c	Then,
c			(|k|+|l|)*(|k-1|+|l-1|)+|m-4|=0
c	Pendant Bond Angles:
c				k,l same as above,
c	Then,
c		(|k-1|+|(m-1)*(m-2)|)*(|l-1|+|(m-2)*(m-3)|)=0
c
c	Criteria for identifying atoms separated by THREE SKELETAL bonds
c	Criteria for identifying atoms separated by TWO SKELETAL 
c	and ONE PENDANT bond

	return
	end
