        PROGRAM chainrlx
c
        implicit none
c
        integer i,j,k,l,m,n,idummy,ib1,ib2
        integer maxconf,natmc,natsu
        integer maxch, maxat,maxbonds,maxatmc,maxatsu
        parameter (maxconf=5000,maxat=20)
        parameter (maxch=100,maxatmc=20,maxatsu=1,maxbonds=20)
        integer nbonds, nconf
        integer nch,natch,iconf,identmc(maxatmc)
        integer dL,penlin
        real box(0:maxconf),denomi
        real b(3*maxch*maxbonds)
	  real x(maxat,maxch),y(maxat,maxch),z(maxat,maxch)
        real halfbox,fullbox
        real t,trun,dt,bx(maxatmc,maxch),by(maxatmc,maxch),
     &  bz(maxatmc,maxch)
        real rx(1:maxconf,maxatmc,maxch),ry(1:maxconf,maxatmc,maxch)
        real rz(1:maxconf,maxatmc,maxch)
        character*12 inpfil,outfil,paramfil
c
        common /System1/    nconf,nch,natch
        common /System2/    halfbox,fullbox
        common /Atoms/      identmc
        common /Read1/      iconf
        common /Length/     dL

        open(unit=3,file='parasub')

c       nconf= # of configurations
        read(3,*) nconf
        read(3,*) nch,natmc,natsu,penlin
        read(3,*) halfbox,fullbox
        read(3,*) dL
        read(3,*) inpfil, outfil
        close(3)

        open(unit=2,file=inpfil)
        open(unit=9,file=outfil)
c      
c       Form bond connectivity arrays
c
        natch=natmc+natsu
        nbonds=natmc-1

        read(2,*) box(0)
        halfbox = halfbox * box(0)
        fullbox = fullbox * box(0)
        close(2)

        open(unit=2,file=inpfil)
        do 17 iconf=1,nconf
          if(mod(iconf,100).eq.0) write(6,*) iconf
          call readcrd(natmc,natsu,nch,penlin,nconf,box,x,y,z)
          call formb(natmc,nch,nbonds,x,y,z,bx,by,bz)
          call build(nconf,natmc,nch,nbonds,x,y,z,bx,by,bz,rx,ry,rz)
   17   continue
        call correlate(nconf,natmc,nbonds,nch,rx,ry,rz)
c
        close(9)
        close(2)
c
c
        STOP
        END
c
c
c
        SUBROUTINE readcrd(natmc,natsu,ch,penlin,conf,box,x,y,z)
c
        implicit none
c
        integer maxconf
        integer maxch, maxat,maxbonds,maxatmc,maxatsu
        parameter (maxconf=5000,maxat=20)
        parameter (maxch=100,maxatmc=20,maxatsu=1,maxbonds=20)
        integer atch,ch,conf,natmc,natsu,penlin
        integer identmc(maxatmc),iconf
        integer nconf,nch,natch
        real x(1:natmc,1:ch),y(1:natmc,1:ch),z(1:natmc,1:ch)
        real box(0:conf),halfbox,fullbox
c
        integer i,j
        real b,xx,yy,zz
c
        common /Read1/      iconf
        common /Atoms/      identmc
        common /System2/    halfbox,fullbox
c
        read(2,*) box(iconf)
        read(2,*)
        read(2,*)
        b=box(iconf)
        halfbox=halfbox*(b/box(iconf-1))
        fullbox=fullbox*(b/box(iconf-1))
c
        do j=1,ch
          do i=1,natmc
            read(2,*) identmc(i),xx,yy,zz
            x(i,j)=b*xx
            y(i,j)=b*yy
            z(i,j)=b*zz
          enddo
          do i=1,natsu
            read(2,*) 
          enddo
        enddo

        do j=1,penlin
            read(2,*) 
        enddo
c
        RETURN
        END
c      
c
c
        SUBROUTINE formb(natmc,ch,bonds,x,y,z,bx,by,bz)
c
        implicit none
c
        integer atch,ch,bonds,natmc,maxatmc
        integer iconf
        real halfbox,fullbox
        real x(1:natmc,1:ch),y(1:natmc,1:ch),z(1:natmc,1:ch)
        real bx(0:natmc,1:ch),by(0:natmc,1:ch),bz(0:natmc,1:ch)
c
        integer i,j,jm1,index,jndex,kndex
        real buff
c
        common /System2/    halfbox,fullbox
        common /Read1/      iconf
c
        do 1 j=1,ch

c        x,y,z are coordinates of the main chain atoms

       do 2 i=1,natmc-1

            buff = x(i+1,j)-x(i,j)
            if (buff.gt. halfbox) buff = buff - fullbox
            if (buff.lt.-halfbox) buff = buff + fullbox
            bx(i,j) = buff


            buff = y(i+1,j)-y(i,j)
            if (buff.gt. halfbox) buff = buff - fullbox
            if (buff.lt.-halfbox) buff = buff + fullbox
            by(i,j)=buff


            buff = z(i+1,j)-z(i,j)
            if (buff.gt. halfbox) buff = buff - fullbox
            if (buff.lt.-halfbox) buff = buff + fullbox
            bz(i,j) = buff


    2     continue
    1   continue
c
        RETURN
        END
c
c
c
        SUBROUTINE build(conf,natmc,ch,bonds,x,y,z,bx,by,bz,rx,ry,rz)
c
        implicit none
c
        integer atch,ch,bonds,conf,iconf,dL,natmc
        real rx(1:conf,1:natmc,1:ch),ry(1:conf,1:natmc,1:ch)
        real rz(1:conf,1:natmc,1:ch)
        real x(1:natmc,1:ch),y(1:natmc,1:ch),z(1:natmc,1:ch)
        real bx(0:natmc,1:ch),by(0:natmc,1:ch),bz(0:natmc,1:ch)
c

c
        integer bonds2,i,j,index,jndex,kndex,lndex
        integer L,L0,L1,L2
        real xini,yini,zini,xend,yend,zend
        real xtmp(natmc,1:ch),ytmp(natmc,1:ch),ztmp(natmc,1:ch)
        real a1,b1,c1,x1,y1,z1,IrIi
c
        common /Read1/      iconf
        common /Length/     dL
c
c.......Backbone Chain..........
c

        do 1 j=1,ch
	    xtmp(1,j) = 0.0d0
	    ytmp(1,j) = 0.0d0
	    ztmp(1,j) = 0.0d0
          do 2 i=2,natmc
            xtmp(i,j)=xtmp(i-1,j)+bx(i,j)
            ytmp(i,j)=ytmp(i-1,j)+by(i,j)
            ztmp(i,j)=ztmp(i-1,j)+bz(i,j)
    2     continue
    1   continue

        L1=1
        L2=bonds-dL+1
        do 10 j=1,ch
          a1=0.
          b1=0.
          c1=0.
          do 20 L0=L1,L2
            L=L0+dL
            x1=xtmp(L,j)-xtmp(L0,j)
            y1=ytmp(L,j)-ytmp(L0,j)
            z1=ztmp(L,j)-ztmp(L0,j)
c
c		transform to unit vectors
c
            IrIi=1./sqrt(x1*x1+y1*y1+z1*z1)
            rx(iconf,L0+dL,j)=rx(iconf,dL,j)+x1*IrIi
            ry(iconf,L0+dL,j)=ry(iconf,dL,j)+y1*IrIi
            rz(iconf,L0+dL,j)=rz(iconf,dL,j)+z1*IrIi
   20     continue
   10   continue

   30   format(i4,3(3x,f8.3))
c
        RETURN
        END
c
c
c
        SUBROUTINE correlate(conf,natmc,bonds,ch,rx,ry,rz)
c
        implicit none
c
        integer conf,natmc,ch,dL,bonds
        real rx(1:conf,natmc,ch),ry(1:conf,natmc,ch),rz(1:conf,natmc,ch)
c
        integer j,L,t,dt,t0,t1,t2
        real x1,y1,z1,x2,y2,z2,dot,p1,p2

        common /Length/     dL
c
        do 1 dt=1,conf-1
          t1=1
          t2=conf-dt
          p1=0.
          p2=0.
          do 3 j=1,ch
            do 4 L=1,bonds-dL+1
              do 2 t0=t1,t2
                t=t0+dt
                x1=rx(t0,L+dL,j)
                y1=ry(t0,L+dL,j)
                z1=rz(t0,L+dL,j)
                x2=rx(t ,L+dL,j)
                y2=ry(t ,L+dL,j)
                z2=rz(t ,L+dL,j)
c
c		Remember: (rx,ry,rz) is a unit vector
c
                dot=x1*x2+y1*y2+z1*z2
                p1=p1+dot
                p2=p2+dot*dot
    2         continue
    4       continue
    3     continue
          write(9,19) dt,p1/float(t2*ch*(bonds-dL+1)),
     &                  1.5*(p2/float(t2*ch*(bonds-dL+1)))-.5
          write(6,*) dt,p1/float(t2*ch*(bonds-dL+1)),
     &                  1.5*(p2/float(t2*ch*(bonds-dL+1)))-.5
    1   continue
c
   19   format (i4,2(2x,f5.3))
        RETURN
        END
